/*
 * qjsoft
 * Copyright (c) 2018 All Rights Reserved.
 */
package com.yqbsoft.laser.service.resources.service;
import java.util.List;

import com.yqbsoft.laser.service.resources.domain.DisDpriceADomain;
import com.yqbsoft.laser.service.resources.model.DisDpriceA;
import com.yqbsoft.laser.service.esb.annotation.ApiMethod;
import com.yqbsoft.laser.service.esb.annotation.ApiService;
import com.yqbsoft.laser.service.esb.core.ApiException;
import com.yqbsoft.laser.service.esb.core.support.BaseService;
import com.yqbsoft.laser.service.esb.core.transformer.QueryResult;
import java.util.Map;
@ApiService(id="disDpriceAService",name="价格",description="价格服务")
public interface DisDpriceAService extends BaseService{
	@ApiMethod(code="rs.dpriceA.savedpriceA",name="价格新增",paramStr="disDpriceADomain",description="价格新增")
	String savedpriceA(DisDpriceADomain disDpriceADomain) throws ApiException;
	
	@ApiMethod(code="rs.dpriceA.savedpriceABatch",name="价格批量新增",paramStr="disDpriceADomainList",description="价格批量新增")
    String savedpriceABatch(List<DisDpriceADomain> disDpriceADomainList) throws ApiException;

	@ApiMethod(code="rs.dpriceA.updatedpriceAState",name="价格状态更新ID",paramStr="dpriceAId,dataState,oldDataState,map",description="价格状态更新ID")
	void updatedpriceAState(Integer dpriceAId, Integer dataState, Integer oldDataState,Map<String,Object> map) throws ApiException;

    @ApiMethod(code="rs.dpriceA.updatedpriceAStateByCode",name="价格状态更新CODE",paramStr="tenantCode,dpriceACode,dataState,oldDataState,map",description="价格状态更新CODE")
	void updatedpriceAStateByCode(String tenantCode,String dpriceACode, Integer dataState, Integer oldDataState,Map<String,Object> map)throws ApiException;

	@ApiMethod(code="rs.dpriceA.updatedpriceA",name="价格修改",paramStr="disDpriceADomain",description="价格修改")
	void updatedpriceA(DisDpriceADomain disDpriceADomain) throws ApiException;

	@ApiMethod(code="rs.dpriceA.getdpriceA",name="根据ID获取价格",paramStr="dpriceAId",description="根据ID获取价格")
    DisDpriceA getdpriceA(Integer dpriceAId);

	@ApiMethod(code="rs.dpriceA.deletedpriceA",name="根据ID删除价格",paramStr="dpriceAId",description="根据ID删除价格")
	void deletedpriceA(Integer dpriceAId) throws ApiException;

	@ApiMethod(code="rs.dpriceA.querydpriceAPage",name="价格分页查询",paramStr="map",description="价格分页查询")
	QueryResult<DisDpriceA> querydpriceAPage(Map<String, Object> map);

	@ApiMethod(code="rs.dpriceA.getdpriceAByCode",name="根据code获取价格",paramStr="tenantCode,dpriceACode",description="根据code获取价格")
    DisDpriceA getdpriceAByCode(String tenantCode,String dpriceACode)throws ApiException;

	@ApiMethod(code="rs.dpriceA.deletedpriceAByCode",name="根据code删除价格",paramStr="tenantCode,dpriceACode",description="根据code删除价格")
	void deletedpriceAByCode(String tenantCode,String dpriceACode)throws ApiException;

}
