/*
 * qjsoft
 * Copyright (c) 2018 All Rights Reserved.
 */
package com.yqbsoft.laser.service.resources.service.impl;

import java.util.ArrayList;
import com.yqbsoft.laser.service.resources.dao.DisDpriceAMapper;
import com.yqbsoft.laser.service.resources.domain.DisDpriceADomain;
import com.yqbsoft.laser.service.resources.model.DisDpriceA;
import com.yqbsoft.laser.service.resources.domain.DisDpriceAReDomain;
import com.yqbsoft.laser.service.esb.core.transformer.PageTools;
import com.yqbsoft.laser.service.esb.core.support.BaseServiceImpl;
import com.yqbsoft.laser.service.tool.util.BeanUtils;
import com.yqbsoft.laser.service.tool.util.StringUtils;
import com.yqbsoft.laser.service.resources.ResourcesConstants;
import com.yqbsoft.laser.service.resources.service.DisDpriceAService;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.yqbsoft.laser.service.esb.core.transformer.QueryResult;
import com.yqbsoft.laser.service.esb.core.ApiException;
public class DisDpriceAServiceImpl  extends BaseServiceImpl implements DisDpriceAService{
	private static final String SYS_CODE = ResourcesConstants.SYS_CODE+".DisDpriceAServiceImpl";
	private DisDpriceAMapper disDpriceAMapper;
	public void setDisDpriceAMapper(DisDpriceAMapper disDpriceAMapper) {
		this.disDpriceAMapper = disDpriceAMapper;
	}
    /**
	 * 获取系统时间
	 * @return
	 */
	private Date getSysDate(){
		try{
			return disDpriceAMapper.selectSysDate();
		}catch(Exception e){
			logger.error(SYS_CODE+".getSysDate", e);
		}
		return null;
	}
	/**
	 * 检测价格参数
	 * @param disDpriceADomain
	 * @return
	 */
	private String checkdpriceA(DisDpriceADomain disDpriceADomain){
		if(null==disDpriceADomain){
			return "参数为空";
		}
		String msg="";
		//TODO 需要根据当前对象做修改
		//if(StringUtils.isBlank(disDpriceADomain.getFtpserverCode())){
		//    msg+= "FtpserverCode为空;";
		//}
		if(StringUtils.isBlank(disDpriceADomain.getTenantCode())){
			msg+= "TenantCode为空;";
		}
		return msg;
	}
	
	/**
	 * 设置价格新增默认值
	 * @param disDpriceA
	 */
	private void setdpriceADefault(DisDpriceA disDpriceA){
		if(null==disDpriceA)return;
		if(null==disDpriceA.getDataState())disDpriceA.setDataState(0);
		Date date = getSysDate();
		if(null==disDpriceA.getGmtCreate())disDpriceA.setGmtCreate(date);
    		disDpriceA.setGmtModified(date);
		if(StringUtils.isBlank(disDpriceA.getDpriceACode())){
    		//disDpriceA.setDpriceACode(createUUIDString());
    		disDpriceA.setDpriceACode(getNo(null, "DisDpriceA", "disDpriceA", disDpriceA.getTenantCode()));
		}
	}
	/**
     * 获取最大号
     * @return
     */
    @SuppressWarnings("unused")
    private int getdpriceAMaxCode() {
        int code = 0;
        try {
            return disDpriceAMapper.getMaxCode();
        } catch (Exception e) {
            logger.error(SYS_CODE + ".getdpriceAMaxCode", e);
        }
        return code;
    }
	
	/**
	 * 设置价格修改默认值
	 * @param disDpriceA
	 */
	private void setdpriceAUpdataDefault(DisDpriceA disDpriceA){
		if(null==disDpriceA)return;
    	disDpriceA.setGmtModified(getSysDate());
	}
	
	/**
	 * 保存价格对象
	 * @param disDpriceA
	 * @throws ApiException
	 */
	private void savedpriceAModel(DisDpriceA disDpriceA) throws ApiException{
		if(null==disDpriceA)return;
		try{
    		disDpriceAMapper.insert(disDpriceA);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".savedpriceAModel.ex", e);
		}
	}
	/**
	 * 批量保存价格对象
	 * @param disDpriceAList
	 * @throws ApiException
	 */
	private void savedpriceABatchModel(List<DisDpriceA> disDpriceAList) throws ApiException{
		if(null==disDpriceAList||disDpriceAList.isEmpty())return;
		try{
    		disDpriceAMapper.insertBatch(disDpriceAList);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".savedpriceABatchModel.ex", e);
		}
	}
	/**
	 * 获取价格信息
	 * @param dpriceAId
	 * @return DisDpriceA
	 */
	private DisDpriceA getdpriceAModelById(Integer dpriceAId){
		if(null==dpriceAId)return null;
		try{
			return disDpriceAMapper.selectByPrimaryKey(dpriceAId);
		}catch(Exception e){
			logger.error(SYS_CODE+".getdpriceAModelById", e);
		}
		return null;
	}
	/**
	 * 获取价格信息
	 * @param map<dpriceACode,tenantCode(可以为空)>
	 * @return DisDpriceA
	 */
	private DisDpriceA getdpriceAModelByCode(Map<String,Object> map){
		if(null==map||map.isEmpty())return null;
		try{
			return disDpriceAMapper.getByCode(map);
		}catch(Exception e){
			logger.error(SYS_CODE+".getdpriceAModelByCode", e);
		}
		return null;
	}
	/**
	 * 删除价格信息
	 * @param map<dpriceACode,tenantCode(可以为空)>
	 */
	private void deldpriceAModelByCode(Map<String,Object> map){
		if(null==map||map.isEmpty())return;
		int i=0;
		try{
			i= disDpriceAMapper.delByCode(map);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".deldpriceAModelByCode.ex", e);
		}
		if(1!=i){
			throw new ApiException(SYS_CODE+".deldpriceAModelByCode.num");
		}
	}
	/**
	 * 删除价格信息
	 * @param dpriceAId
	 * @throws ApiException
	 */
	private void deletedpriceAModel(Integer dpriceAId) throws ApiException{
		if(null==dpriceAId)return;
		int i=0;
		try{
			i= disDpriceAMapper.deleteByPrimaryKey(dpriceAId);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".deletedpriceAModel.ex", e);
		}
		if(1!=i){
			throw new ApiException(SYS_CODE+".deletedpriceAModel.num");
		}
	}
	/**
	 * 更新价格对象
	 * @param disDpriceA
	 * @throws ApiException
	 */
	private void updatedpriceAModel(DisDpriceA disDpriceA) throws ApiException{
		if(null==disDpriceA)return;
		int i=0;
		try{
			i=disDpriceAMapper.updateByPrimaryKey(disDpriceA);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".updatedpriceAModel.ex", e);
		}
		if(1!=i){
			throw new ApiException(SYS_CODE+".updatedpriceAModel.num");
		}
	}
	/**
	 * 更新价格状态
	 * @param dpriceAId
	 * @param dataState
	 * @param oldDataState
	 * @throws ApiException
	 */
	private void updateStatedpriceAModel(Integer dpriceAId, Integer dataState, Integer oldDataState,Map<String,Object> expmap) throws ApiException{
		if(null==dpriceAId||null==dataState)return;
		Map<String,Object> map=new HashMap<String, Object>();
		map.put("dpriceAId", dpriceAId);
		map.put("dataState", dataState);
		map.put("oldDataState", oldDataState);
		if(null!=expmap&&!expmap.isEmpty()){
			map.putAll(expmap);
		}
		int i=0;
		try{
			i=disDpriceAMapper.updateStateByPrimaryKey(map);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".updateStatedpriceAModel.ex", e);
		}
		if(i<=0){
			throw new ApiException(SYS_CODE+".updateStatedpriceAModel.null");
		}
	}
	/**
	 * 更新价格状态
	 * @param tenantCode
	 * @param dpriceACode
	 * @param dataState
	 * @param oldDataState
	 * @throws ApiException
	 */
	private void updateStatedpriceAModelByCode(String tenantCode,String dpriceACode, Integer dataState, Integer oldDataState,Map<String,Object> expmap) throws ApiException{
		if(StringUtils.isBlank(dpriceACode)||null==dataState)return;
		Map<String,Object> map=new HashMap<String, Object>();
		map.put("tenantCode",tenantCode);
		map.put("dpriceACode",dpriceACode);
		map.put("dataState", dataState);
		map.put("oldDataState", oldDataState);
		if(null!=expmap&&!expmap.isEmpty()){
			map.putAll(expmap);
		}
		int i=0;
		try{
			i=disDpriceAMapper.updateStateByCode(map);
		}catch(Exception e){
			throw new ApiException(SYS_CODE+".updateStatedpriceAModelByCode.ex", e);
		}
		if(i<=0){
			throw new ApiException(SYS_CODE+".updateStatedpriceAModelByCode.null");
		}
	}
	
	/**
	 * domain转成价格MODEL
	 * @param disDpriceADomain
	 * @return DisDpriceA
	 */
	private DisDpriceA makedpriceA(DisDpriceADomain disDpriceADomain,DisDpriceA disDpriceA){
		if(null==disDpriceADomain)return null;
		if(null==disDpriceA) disDpriceA=new DisDpriceA();
		try {
			BeanUtils.copyAllPropertys(disDpriceA, disDpriceADomain);
			return disDpriceA;
		} catch (Exception e) {
			logger.error(SYS_CODE+".makedpriceA", e);
		}
		return null;
	}
	
	/**
	 * 价格MODEL转成Redomain
	 * @param DisDpriceA
	 * @return Domain
	 */
	@SuppressWarnings("unused")
	private DisDpriceAReDomain makeDisDpriceAReDomain(DisDpriceA disDpriceA){
		if(null==disDpriceA)return null;
    	DisDpriceAReDomain disDpriceAReDomain=new DisDpriceAReDomain();
		try {
			BeanUtils.copyAllPropertys(disDpriceAReDomain, disDpriceA);
			return disDpriceAReDomain;
		} catch (Exception e) {
			logger.error(SYS_CODE+".makeDisDpriceAReDomain", e);
		}
		return null;
	}
	
	/**
	 * 分页查询价格
	 * @param parammap
	 * @return DisDpriceA
	 */
	private List<DisDpriceA> querydpriceAModelPage(Map<String, Object> parammap) {
		try{
			return disDpriceAMapper.query(parammap);
		}catch(Exception e){
			logger.error(SYS_CODE+".querydpriceAModel", e);
		}
		return null;
	}
	/**
	 * 获取记录数
	 * @param map
	 * @return 记录数
	 */
	private int countdpriceA(Map<String, Object> map) {
		int i = 0;
		try {
			i = disDpriceAMapper.count(map);
		} catch (Exception e) {
			logger.error(SYS_CODE+".countdpriceA", e);
		}
		return i;
	}
	/**
	 * disDpriceADomain转成DisDpriceA
	 * @param disDpriceADomain
	 * @return DisDpriceA
	 */
	private DisDpriceA createDisDpriceA(DisDpriceADomain disDpriceADomain) {
		//1.检测
		String msg=checkdpriceA(disDpriceADomain);
		if(StringUtils.isNotBlank(msg)){
			throw new ApiException(SYS_CODE+".savedpriceA.checkdpriceA", msg);
		}
		//2.转成MODEL
    	DisDpriceA disDpriceA=makedpriceA(disDpriceADomain, null);
		//3.默认值
		setdpriceADefault(disDpriceA);
		return disDpriceA;
	}


	@Override
	public String savedpriceA(DisDpriceADomain disDpriceADomain) throws ApiException {
    DisDpriceA disDpriceA=createDisDpriceA(disDpriceADomain);
		//4.保存
		savedpriceAModel(disDpriceA);
		return disDpriceA.getDpriceACode();
	}

	@Override
	public String savedpriceABatch(List<DisDpriceADomain> disDpriceADomainList) throws ApiException{
		if(null==disDpriceADomainList||disDpriceADomainList.isEmpty())return null;
		List<DisDpriceA> disDpriceAList=new ArrayList<DisDpriceA>();
		DisDpriceA disDpriceA;
		String code="";
		for (DisDpriceADomain disDpriceADomain : disDpriceADomainList) {
			disDpriceA=createDisDpriceA(disDpriceADomain);
			code=disDpriceA.getDpriceACode();
    		disDpriceAList.add(disDpriceA);
		}
		savedpriceABatchModel(disDpriceAList);
		return code;
	}
	
	@Override
	public void updatedpriceAState(Integer dpriceAId, Integer dataState, Integer oldDataState,Map<String,Object> map)
			throws ApiException {
		if(null == dpriceAId)return ;
		updateStatedpriceAModel(dpriceAId, dataState, oldDataState,map);
	}
	
	@Override
	public void updatedpriceAStateByCode(String tenantCode,String dpriceACode, Integer dataState, Integer oldDataState,Map<String,Object> map)
			throws ApiException {
		if(StringUtils.isBlank(dpriceACode)||StringUtils.isBlank(tenantCode))return ;
		updateStatedpriceAModelByCode(tenantCode,dpriceACode, dataState, oldDataState,map);
	}
	

	@Override
	public void updatedpriceA(DisDpriceADomain disDpriceADomain) throws ApiException {
		//1.检测
		String msg=checkdpriceA(disDpriceADomain);
		if(StringUtils.isNotBlank(msg)){
			throw new ApiException(SYS_CODE+".updatedpriceA.checkdpriceA", msg);
		}
		//2.获取MODEL
    	DisDpriceA oldDisDpriceA=getdpriceAModelById(disDpriceADomain.getDpriceAId());
		if(null==oldDisDpriceA){
			throw new ApiException(SYS_CODE+".updatedpriceA.null", "数据为空");
		}
		//3.转成MODEL
    	DisDpriceA disDpriceA=makedpriceA(disDpriceADomain, oldDisDpriceA);
		//4.默认值
		setdpriceAUpdataDefault(disDpriceA);
		//5.保存
		updatedpriceAModel(disDpriceA);
	}

	@Override
	public DisDpriceA getdpriceA(Integer dpriceAId) {
		if(null == dpriceAId)return null;
		return getdpriceAModelById(dpriceAId);
	}

	@Override
	public void deletedpriceA(Integer dpriceAId) throws ApiException {
		if(null == dpriceAId)return;
		deletedpriceAModel(dpriceAId);
	}

	@Override
	public QueryResult<DisDpriceA> querydpriceAPage(Map<String, Object> map) {
		List<DisDpriceA> disDpriceAList = querydpriceAModelPage(map);
		QueryResult<DisDpriceA> queryResult = new QueryResult<DisDpriceA>();
		PageTools pageTools = new PageTools();
		pageTools.setRecordCount(countdpriceA(map));
		queryResult.setPageTools(pageTools);
		queryResult.setList(disDpriceAList);
		return queryResult;
	}
	
	@Override
	public DisDpriceA getdpriceAByCode(String tenantCode,String dpriceACode) throws ApiException{
		if(StringUtils.isBlank(dpriceACode)||StringUtils.isBlank(tenantCode))return null;
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("tenantCode", tenantCode);
		map.put("dpriceACode", dpriceACode);
		return getdpriceAModelByCode(map);
	}

	@Override
	public void deletedpriceAByCode(String tenantCode,String dpriceACode) throws ApiException {
		if(StringUtils.isBlank(dpriceACode)||StringUtils.isBlank(tenantCode))return ;
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("tenantCode", tenantCode);
		map.put("dpriceACode", dpriceACode);
		deldpriceAModelByCode(map);
	}

}
